package sri;

import ims.*;
import java.io.*;  
import java.util.*;

 
// Example class
public class MASTER {
  public static void main(String[] args)throws IOException{
	
	
  // Stuff for MetaMetaData
	imsVCard[] author = new imsVCard[1];
	  author[0] = new imsVCard("Grahame Murray", "SRI International", "grahame.murray@sri.com", "333 Ravenswood Ave.=0A=\nMenlo Park=0A=\nCA=0A=\n94025=0A=\nUSA", "(650) 859-2000");

    imsContribute[] contrib = new imsContribute[1];
      contrib[0] = new imsContribute(new imsLangString("Author"), author, new imsDateTime("1999-09-09"));

    imsCatalogEntry[] cat = new imsCatalogEntry[1];
      cat[0] = new imsCatalogEntry("ISBN", new imsLangString("1-424-128924-0342"));
	
	
	
  // Stuff for General
 	imsLangString[] title = new imsLangString[5];
 	  title[0] = new imsLangString("XML Master Document", "en-US");
   	  title[1] = new imsLangString("Document Principal De Xml", "fr");
   	  title[2] = new imsLangString("Originalbeleg Xml", "de"); 
   	  title[3] = new imsLangString("Documento Matrice Di Xml", "it"); 
   	  title[4] = new imsLangString("Documento Principal De Xml", "es"); 
 
  	imsCatalogEntry[] catalogentry = new imsCatalogEntry[1];
  	  catalogentry[0] = new imsCatalogEntry("ISBN", new imsLangString("1-424-128924-0342"));
	
	String[] language = new String[1];
	  language[0] = "en-US";
	
	imsLangString[] desc = new imsLangString[1];
	  desc[0] = new imsLangString("");


    imsLangString[] keyw1 = new imsLangString[2];
      keyw1[0] = new imsLangString("XML");
      keyw1[1] = new imsLangString("XML", "fr");

    imsLangString[] keyw2 = new imsLangString[2];
      keyw2[0] = new imsLangString("Metadata");
      keyw2[1] = new imsLangString("DataMeta", "fr");

    imsLangString[] keyw3 = new imsLangString[4];
      keyw3[0] = new imsLangString("Instructional Technology");
      keyw3[1] = new imsLangString("D'instruction Technologie", "fr");
      keyw3[2] = new imsLangString("Anweisende Technologie", "de");
      keyw3[3] = new imsLangString("Educacional Tecnologia", "es");

    imsLangString[] keyws = new imsLangString[3];
      keyws[0] = new imsLangString(keyw1);
      keyws[1] = new imsLangString(keyw2);
      keyws[2] = new imsLangString(keyw3);

    imsLangString[] cov = new imsLangString[1];
      cov[0] = new imsLangString("");



  // Stuff for LifeCycle
	imsVCard[] authors = new imsVCard[4];
	  authors[0] = new imsVCard("Grahame Murray", "SRI International", "grahame.murray@sri.com", "333 Ravenswood Ave.=0A=\nMenlo Park=0A=\nCA=0A=\n94025=0A=\nUSA", "(650) 859-2000");
	  authors[1] = new imsVCard("Philip Vahey", "SRI International", "phil.vahey@sri.com", "333 Ravenswood Ave.=0A=\nMenlo Park=0A=\nCA=0A=\n94025=0A=\nUSA", "(650) 859-2000");
	  authors[2] = new imsVCard("Jamie Fenton", "SRI International", "jfenton@unix.sri.com", "333 Ravenswood Ave.=0A=\nMenlo Park=0A=\nCA=0A=\n94025=0A=\nUSA", "(650) 859-2000");
	  authors[3] = new imsVCard("Hua Ji", "SRI International", "hua@erg.sri.com", "333 Ravenswood Ave.=0A=\nMenlo Park=0A=\nCA=0A=\n94025=0A=\nUSA", "(650) 859-2000");
	
	imsVCard[] publishers = new imsVCard[1];
	  publishers[0] = new imsVCard("", "SRI International", "", "", "");

	imsContribute contribute[] = new imsContribute[2];
	  contribute[0] = new imsContribute(new imsLangString("Author"), authors, new imsDateTime("1999-09-09"));
	  contribute[1] = new imsContribute(new imsLangString("Publisher"), publishers, new imsDateTime("1999-09-09"));
	
	
	
  // Stuff for Technical
	imsLangString[] format = new imsLangString[2];
	  format[0] = new imsLangString("Java 1.1");
	  format[1] = new imsLangString("XML");
	
	imsLocation[] location = new imsLocation[1];
	  location[0] = new imsLocation("http://www.sri.com/", "URI");
	
	imsRequirements[] requirements = new imsRequirements[1];
	  requirements[0] = new imsRequirements(new imsLangString("Browser"),
	                                        new imsLangString("Internet Explorer"),
	                                        "5.0",
	                                        "");


  // Stuff for Educational
    imsLangString[] type = new imsLangString[2];
      type[0] = new imsLangString("Exercise");
      type[1] = new imsLangString("Simulation");
    
    imsLangString[] role = new imsLangString[1];
      role[0] = new imsLangString("Author");
     
    imsLangString[] context = new imsLangString[2];
      context[0] = new imsLangString("High School");
      context[1] = new imsLangString("Undergraduate");
    
    imsLangString[] agerange = new imsLangString[2];
      agerange[0] = new imsLangString("Adults");
      agerange[1] = new imsLangString("Seniors");
    
    String[] lang = new String[1];
      lang[0] = "en-US";
      
    imsEducational educational = new imsEducational(new imsLangString("Active"), type,
                                                    "1", "4",
                                                    role, context,
                                                    agerange, "0",
                                                    new imsDateTime("P2D"), new imsLangString("XML Tool"),
                                                    lang);


  // Stuff for Rights	
	imsLangString[] description = new imsLangString[1];
	  description[0] = new imsLangString("Open Source", "en-US");
	
	
	
  // Stuff for Relation
    imsRelation[] relation = new imsRelation[2];
    relation[0] = new imsRelation(new imsLangString("WasCommissionedBy"), 
                                  new imsResource(new imsLangString("Sun MicroSystems")));
    relation[1] = new imsRelation(new imsLangString("References"),
                                  new imsResource(new imsLangString("International Standards Orgranization (ISO)")));
 
 
  // Stuff for Annotation
    imsAnnotation[] annotation = new imsAnnotation[1];
    annotation[0] = new imsAnnotation(new imsVCard("Chris Winters", "Sun MicroSystems", "", "901 San Antonio Road =0A=\nMS MPK15-204=0A=\nPalo Alto, CA 94303=0A=", ""), 
                                      new imsDateTime("1999-09-09"), 
                                      new imsLangString("Commissioning Agent"));
	
	
	
  // Stuff for Classification
	imsLangString[] descriptions = new imsLangString[3];
	  descriptions[0] = new imsLangString("An API for generating properly formatted IMS MetaData XML", "en-US");
	  descriptions[1] = new imsLangString("Eine API fur das Festlegen richtig formatierten IMS MetaData XML", "de");
	  descriptions[2] = new imsLangString("Un API pour produire d'IMS correctement formate MetaData XML", "fr");
	
    imsEntry[] entry=new imsEntry[2];
      entry[0] = new imsEntry(new imsLangString("First Label", "en-US"), "011");
      entry[1] = new imsEntry(new imsLangString("Second Label"), "012");
	
	imsTaxonPath[] taxonpaths = new imsTaxonPath[1];
	  taxonpaths[0] = new imsTaxonPath("Grahame Murray", entry);
	
	imsLangString[] keywords = new imsLangString[3];
	  keywords[0] = new imsLangString("IMS", "en-US");
	  keywords[1] = new imsLangString("Metadata", "en-US");
	  keywords[2] = new imsLangString("XML", "en-US");
	
	imsClassification[] classification = new imsClassification[1];
	  classification[0] = new imsClassification(new imsLangString("Discipline", "en-US"), 
	                                            taxonpaths,
												new imsLangString(descriptions), 
												keywords);
	
	
	
  // Create a Master object
	imsMaster master = new imsMaster(new imsMetaMetaData(cat, contrib, "IMSCORE:1.0", "en-US"),
							   new imsGeneral(new imsLangString(title), catalogentry, language, desc, keyws, cov, new imsLangString("Mixed"), "3"),
							   new imsLifeCycle(new imsLangString("1.0"), new imsLangString("Final"), contribute),
							   new imsTechnical(format, location, "50K", requirements, new imsLangString("Unzip,Compile"), new imsLangString(""), new imsDateTime("")),
							   educational, new imsRights(new imsLangString("no"), new imsLangString("no", "en-US"), description),
							   relation, annotation,
							   classification);
			
				
  // Print it to file	   
	master.imsWrite2XMLFile("Master", master.imsWrite2XMLString());
  }
}
